// Helianto -- static website generator
// Copyright © 2015-2016 Mickaël RAYBAUD-ROIG
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.


use std::path::Path;
use std::collections::HashMap;
use super::Result;

mod markdown;
pub use self::markdown::MarkdownReader;

pub type Metadata = HashMap<String, String>;

pub trait Reader {
    fn extensions() -> &'static [&'static str] where Self: Sized;
    fn new(settings: &super::Settings) -> Self where Self: Sized;
    fn load(&self, path: &Path) -> Result<(String, Metadata)>;
}
